=== debian/changelog ===
lammps (20191120+dfsg1-2build2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 19:16:27 +0100

lammps (20191120+dfsg1-2build1) focal; urgency=medium

  * No-change rebuild for netcdf soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 30 Jan 2020 18:01:42 +0100

lammps (20191120+dfsg1-2) unstable; urgency=medium

  * [986614f] Remove PKG_MEAM and PKG_REAX options
  * [b6ac058] Minor fixes in d/copyright and d/patches
  * [67a37ea] Use secure URI in Homepage field.
  * [46d7c3a] Enable PKG_KIM

 -- Anton Gladky <gladk@debian.org>  Wed, 15 Jan 2020 21:50:25 +0100

lammps (20191120+dfsg1-1) unstable; urgency=medium

  * Team upload.
  * New upstream patch release 20 November 2019.
  * rename debian patches build_docs_direct.patch as build_docs.patch:
    use system sphinx to build docs. Build-Depends: virtualenv.

 -- Drew Parsons <dparsons@debian.org>  Fri, 03 Jan 2020 11:25:33 +1100
