=== debian/watch ===
# upstream tarballs can be obtained from https://github.com/lammps/lammps/tags
# (or latest stable version from https://lammps.sandia.gov/download.html)
#
# Upstream uses human text (date) based tags, which do not provide
# version number ordering (01Apr2019 would order ahead of 07Jan2019)
#
# Debian versions are therefore expressed as ordinals,
# where 20190401 orders after 20190107.
#
# But it is not convenient to convert 01Apr2019 to 20190401 etc.
# in the syntax of a debian/watch file.
#
# Hence this watch file provides no watch.
# Upstream tarballs must be downloaded and imported manually.
#
# Repack the upstream tarball to remove Files-Excluded
# (listed in debian/copyright) with:
# mk-origtargz -v <release>+dfsg1 ../lammps-upstream.tar.gz
